unit uSignDemo;
interface
uses

//use the model
Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI, CommDlg, MMSystem, WinSock, IniFiles, DBTables, BDE,
StdCtrls, ComObj, ADODB, Imm, DbCtrls, Db, Registry, Buttons, ExtCtrls;
{uses
Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
Dialogs, StdCtrls, Buttons, ExtCtrls, registry; }
type
  TForm1 = class(TForm)
    btnStartCapture: TBitBtn;
    btnStop: TBitBtn;
    btnOpen: TBitBtn;
    btnClear: TBitBtn;
    img: TBevel;
    Bevel1: TBevel;
    procedure btnOpenClick(Sender: TObject);
    function getcom():integer;
    procedure FormCreate(Sender: TObject);
    procedure btnStartCaptureClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
 //  Declara??es necessrias:
var
  g_ArrayPoints: array  of TPoint;
  g_ArrayPointsLen: Integer;
  g_SigViewXLeft:integer;
  g_SigViewTop:integer;
  g_XScale:single;
  g_YScale:single;
  g_SigViewWidth:integer;
  g_SigViewHeight:integer;
  g_buSignOpened:boolean;
const
  SIGN_FAIL = 0;
  SIGN_SUCCESS = 1;
  SIGN_NOT_SUPPORTED = 50;
  SIGN_PARAMETER_ERR = 99;
  SIGN_BUFFER_LACK = 101;
  SIGN_PORT_OPENED = 200;
  SIGN_PORT_CLOSED = 201;
  //the uSign SDK APIs List

  Function uSign_OpenUSBHID():byte;stdcall;External 'uSignKit.dll';
  Function uSign_OpenPort(Comport:integer;Baud:integer;Parity:char; Stop:integer ):byte ;stdcall;External 'uSignKit.dll';
  Function uSign_ClosePort():byte;stdcall;External 'uSignKit.dll';

  Function uSign_AddPointHandle ( callback: Pointer;  param : pinteger) : integer;stdcall;External 'uSignKit.dll';
  Function uSign_StartCapturing  ( byType: Byte): Byte ;stdcall;External 'uSignKit.dll';
  Function uSign_StopCapturing () : Byte  ;stdcall;External 'uSignKit.dll';
  Function uSign_ClearScreen () : Byte ;stdcall;External 'uSignKit.dll';
  procedure key_handle(pBuff: Pointer; datelen: Integer; param: Pointer);stdcall;
 type
  TKEY_FUNC = procedure(pBuff: Pointer; datelen: Integer; param: Pointer);stdcall;


implementation

//get the data
procedure key_handle(pBuff: Pointer; datelen: Integer; param: Pointer)     ;stdcall;
var
  length:Integer;
  ptData:array of Integer;
  lenF:single   ;
  str:string;
  i:integer;
  g_Temp:TPoint;
  starX:integer;
  starY:integer;
  endX:integer;
  endY:integer;


  //draw var
  index : integer;

begin
  lenF:=datelen/2;
  length:=round(lenF );
  Pointer(ptData) :=    pBuff;
//  ptData:=Integer(pBuff);
 
  str := inttostr(length);
//ptData:=   pBuff;
  SetLength( g_ArrayPoints,  (g_ArrayPointsLen+ length+1));

  //save the signature data to current array
  for i:=0 to length-1 do
  begin
    g_Temp.x := ptData[i*2];
    g_Temp.y := ptData[i*2+1] ;
    g_ArrayPoints[g_ArrayPointsLen]:=g_Temp;
    g_ArrayPointsLen:=g_ArrayPointsLen+1;
  end;//end for
  //To draw the points:
    index  := g_ArrayPointsLen - length - 1  ;
    //'display the stroke
        If index > 0 Then
        begin
            For i := index - 1 To index + length - 2  do
            begin
                starX := g_ArrayPoints[i].X ;
                starY := g_ArrayPoints[i].Y ;
                If (starX = -1) And (starY = -1) Then
                begin
                    Continue  ;
                End;
                endX := g_ArrayPoints[i+1].X;
                endY := g_ArrayPoints[i+1].Y ;
                starX := g_SigViewXLeft + round(starX * g_XScale) ;
                starY := g_SigViewTop + round(starY * g_YScale) ;
                If ( endX=-1 ) And (endY = -1) Then
                begin
                      form1.canvas.moveto(starX,starY);
                      form1.canvas.lineto(starX,starY);
                end
                Else
                begin
                      endX := g_SigViewXLeft + round(endX * g_XScale);
                      endY := g_SigViewTop + round(endY * g_YScale);
                      form1.canvas.moveto(starX,starY);
                      form1.canvas.lineto(endX,endY);
                End;//end else begin
            end;// 'end for
        end //end if
        Else
        begin
           // 'draw the begin stroke
            If g_ArrayPointsLen > 0 Then
            begin
     //       str := inttostr(length)+'\n ';
      //      OutputDebugString(PChar(str)   );
                For i := 0 To length - 2  do
                begin
         //         str := inttostr( i)+'\n ';
           //       OutputDebugString(PChar(str)   );
                    
                    starX := g_ArrayPoints[i].X ;
                    starY :=  g_ArrayPoints[i].Y ;
                    If (starX= -1 ) And ( starY =-1) Then
                    begin
                        Continue ;
                    End;

                    // begin to draw line by two points.
                    //
                    endX := g_ArrayPoints[i+1].X  ;
                    endY := g_ArrayPoints[i+1].Y  ;
                    starX := g_SigViewXLeft + round(starX * g_XScale);
                    starY := g_SigViewTop + round(starY * g_YScale );
                    If (endX= -1 ) And (endY = -1) Then
                    begin
                      form1.canvas.moveto(starX,starY);
                      form1.canvas.lineto(starX,starY);
                    end
                    Else
                    begin
                       endX := g_SigViewXLeft + round(endX * g_XScale);
                      endY := g_SigViewTop + round(endY * g_YScale);
                      form1.canvas.moveto(starX,starY);
                      form1.canvas.lineto(endX,endY);
                    End ;
                end;// 'end for

            End;//end if
        End ;//end else begin;
 
      //Result:=0;
         
end;
{$R *.dfm}
// button click to read data\
// thread to start capture.
function SignatureCaptureThread  ():integer;
var
  HW: HWND;
  callback: TKEY_FUNC;
  
  point: Pointer;
 begin
    callback := key_handle;

    GetDC(HW);
    point := @HW;
    uSign_AddPointHandle(@callback, point);
    uSign_StartCapturing(0);//{you should create and start a thread here, and the function 'uSign_StartCapturing' should be invoked in the created thread.}
    Result:=0;
end;

function TForm1.getcom():integer;
  var
      reg   :   TRegistry;
      ts   :   TStrings;
      i   :   integer;
      sName,sPort:string;
      ret:byte;
  begin
      reg := TRegistry.Create();
      ts  := TStringList.Create;
      try
          reg.RootKey := HKEY_LOCAL_MACHINE;
          reg.OpenKey('hardware\devicemap\serialcomm',false);
          reg.GetValueNames(ts);
          for   i   :=   0   to   ts.Count   -1   do
          begin
              sName:=LowerCase(Trim(ts.Strings[i]));
              //õ
              sPort   :=   UpperCase(Trim(reg.ReadString(sName)));
              if Copy(sPort,1,3) <> 'COM' then Continue;
              sPort:=Copy(sPort,4,Length(sPort));
              ret:=uSign_OpenPort(  strtoint   ( sPort),9600,'N',1);
              if (ret = SIGN_SUCCESS) or (ret = SIGN_PORT_OPENED) then
              begin
                    btnOpen.Enabled := false;
                    btnStartCapture.Enabled :=true;
                    btnStop.Enabled :=true;
                    btnClear.Enabled:=true;
                    g_buSignOpened:=true;
                    uSign_ClearScreen();
                    Result:=0;
                       Exit;
              end ;//end if
           //
          end;//end for
      finally
          ts.Free;
          reg.CloseKey;
          reg.free;
      end;
      Result:=0;
end;

procedure TForm1.btnOpenClick(Sender: TObject);
var
Result: byte;

begin
  Screen.Cursor:=crHourGlass;
  Result := uSign_OpenUSBHID();
  if (Result = SIGN_SUCCESS) or (Result = SIGN_PORT_OPENED) then
  begin
    btnOpen.Enabled := false;
    btnStartCapture.Enabled :=true;
    btnClear.Enabled:=true;
    btnStop.Enabled := false;
    g_buSignOpened:=true;

    uSign_ClearScreen;
  end
  else
  begin
    //open port
     getcom;
  end;
  Screen.Cursor := crDefault;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.canvas.pen.width:=1;
  form1.canvas.pen.color:=$00a00000;
  g_SigViewWidth :=  img.Width;
  g_SigViewHeight :=  img.Height;
  g_SigViewXLeft:=0;
  g_SigViewTop:=0;
  g_XScale:=  (g_SigViewWidth/1024);
  g_YScale:=  (g_SigViewHeight/1024);
  btnOpen.Enabled := true;
  btnStartCapture.Enabled :=false;
  btnStop.Enabled :=false;
  btnClear.Enabled:=false;
  g_buSignOpened:=false;
end;

procedure TForm1.btnStartCaptureClick(Sender: TObject);
var
  hThread:Thandle;
  ThreadID:DWord;
begin
  g_ArrayPointsLen:=0;
SetLength( g_ArrayPoints,  ( g_ArrayPointsLen+1));
  form1.Refresh();
 // hThread:=0;
  ThreadID:=0;
  btnStartCapture.Enabled := false;
  btnStop.Enabled := true;
  hthread:=CreateThread(nil,0,@SignatureCaptureThread,nil,0,ThreadID);
  if hThread=0 then
    showmessage('Didn''t CreateaThread');
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  g_ArrayPointsLen:=0;
SetLength( g_ArrayPoints, ( g_ArrayPointsLen+1));
  form1.Refresh();
  uSign_ClearScreen();
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  uSign_StopCapturing();
  btnStartCapture.Enabled := true;
  btnStop.Enabled := false;


end;

procedure TForm1.FormPaint(Sender: TObject);
Var
i:integer;
starX:integer;
starY:integer;
endX :integer;
endY :integer;
begin
//// draw lines
  if g_ArrayPointsLen   >0  then
  begin
            For  i := 0 To g_ArrayPointsLen - 2   do
            begin
                starX := g_ArrayPoints[i].X ;
                starY := g_ArrayPoints[i].Y ;
                //'you can check the pixel here
                //'if the pixel in the erea of button you created, then call the button click event function and return here.
                If (-1 = starX) And (-1 = starY) Then
                begin
                    Continue ;
                End;
                //draw the lines ;;;

                endX := g_ArrayPoints[i+1].X ;
                endY := g_ArrayPoints[i+1].Y ;
                starX := g_SigViewXLeft + round(starX * g_XScale);
                starY := g_SigViewTop + round(starY * g_YScale);  
                If ( endX = -1 ) And (endY = -1) Then
                begin
                    form1.canvas.moveto(starX,starY);
                    form1.canvas.lineto(starX,starY);
                end//end if
                Else
                begin
                    endX := g_SigViewXLeft + round(endX * g_XScale) ;
                    endY := g_SigViewTop + round(endY * g_YScale)   ;
                    form1.canvas.moveto(starX,starY);
                    form1.canvas.lineto(endX,endY);
                end;//end else
            end;
  end; //end if
////
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// 
  if g_buSignOpened = true then
  begin
    uSign_StopCapturing;
    uSign_ClosePort;
  end;
end;

end.
